/* * arch/ppc/platforms/fsm73xx.h
 * 
 * Board declarations for Netgear FSM73xx boards.
 *
 * Author: John W. Linville
 *         linville@lvl7.com
 *
 * Copyright 2003 LVL7 Systems Inc.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */
#ifndef	__PPC_PLATFORMS_FSM73XX_H_
#define	__PPC_PLATFORMS_FSM73XX_H_

/*
 * Use PPCBoot's bd_t definition...
 */
#include <asm/ppcboot.h>

#define FSM73XX_EUMB_BASE	0xFC000000

/*
 * CPLD register addresses and related definitions...
 */
#define FSM73XX_CPLD_PBASE	0x70000000
#define FSM73XX_CPLD_VBASE	0xfd000000
#define FSM73XX_CPLD_SIZE	0x00001000

#define FSM73XX_CPLD_RESET_ADDR	(FSM73XX_CPLD_VBASE + 0x20)
#define FSM73XX_CPLD_RESET_VAL	0x83

void fsm73xx_find_bridges(void);

#endif	/* __PPC_PLATFORMS_FSM73XX_H_ */
